//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		FBXGlobalCamera.h
 * @brief		FBX SDK GlobalCameraNXt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_FBXGlobalCamera_H_
#define INCG_IRIS_FBXGlobalCamera_H_

//======================================================================
// include
#ifdef _IRIS_SUPPORT_FBX
#include "../../../fnd/types/FndExecutor.h"
#include "FBXCamera.h"
#endif

#ifdef _IRIS_SUPPORT_FBX

namespace iris {
namespace gx {
namespace fbx
{

//======================================================================
// class
/**
 * @ingroup	FBX
 * @brief	FBX SDK GlobalCamera
*/
class CFBXGlobalCamera : public CFBXCamera
{
public:
	// RXgN^
	CFBXGlobalCamera(void);
	// RXgN^
	CFBXGlobalCamera(KFbxScene* scene);
	// RXgN^
	CFBXGlobalCamera(CFBXGlobalCamera& obj);
	// fXgN^
	virtual ~CFBXGlobalCamera(void);

public:
	// Jݒ
	void	SetCamera(KTime& pTime);
};


}	// end of namespace fbx
}	// end of namespace gx
}	// end of namespace iris

#endif

#endif
